VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Menu with Bitmap Graphics"
   ClientHeight    =   2070
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   18
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   2070
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   330
      Left            =   450
      ScaleHeight     =   330
      ScaleWidth      =   345
      TabIndex        =   0
      Top             =   885
      Visible         =   0   'False
      Width           =   345
   End
   Begin VB.Menu Bitmaps 
      Caption         =   "Bitmaps"
      Begin VB.Menu MyMenu 
         Caption         =   "Menu1"
         Index           =   0
      End
      Begin VB.Menu MyMenu 
         Caption         =   "Menu2"
         Index           =   1
      End
      Begin VB.Menu MyMenu 
         Caption         =   "Menu3"
         Index           =   2
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'  ******************************
'  ******************************
'  ** MASTERING VB6            **
'  ** by Evangelos Petroutos   **
'  ** SYBEX, 1998              **
'  ******************************
'  ******************************
Option Explicit

Private Declare Function GetMenu Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetSubMenu Lib "user32" (ByVal hMenu As Long, _
    ByVal nPos As Long) As Long
Private Declare Function GetMenuItemID Lib "user32" (ByVal hMenu As Long, _
    ByVal nPos As Long) As Long
Private Declare Function ModifyMenu Lib "user32" Alias "ModifyMenuA" _
    (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long, _
    ByVal wIDNewItem As Long, ByVal lpString As Any) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, _
    ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, _
    ByVal hObject As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, _
    ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
    ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) _
    As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Const SRCCOPY = &HCC0020
Const MF_BYPOSITION = &H400&
Const MF_BITMAP = &H4&

Private Sub Form_Load()
Dim Width As Integer, Height As Integer
Dim hTmpDC As Long, hMenuID As Long
Dim hBitmap As Long, retValue As Long
Dim tmpID As Long
Dim fileName As String
Dim menuPos As Integer, menuID As Long
    
    'Set menu position and file name
    menuPos = 0
    fileName = App.Path & "\verdana.bmp"
    Picture1.Picture = LoadPicture(fileName)
    Width = 64
    Height = 16
    'Get handle to menu
    hMenuID = GetSubMenu(GetMenu(Me.hwnd), menuPos)
    'Create device context to store bitmap
    hTmpDC = CreateCompatibleDC(Picture1.hdc)
    'Create the bitmap for the picture
    hBitmap = CreateCompatibleBitmap(Picture1.hdc, Width, Height)
    'Select bitmap into temporary dc
    tmpID = SelectObject(hTmpDC, hBitmap)
    'Copy contents from picture control to DC
    retValue = BitBlt(hTmpDC, 0, 0, Width, Height, _
               Picture1.hdc, 0, 0, SRCCOPY)
    'Deselect bitmap
    tmpID = SelectObject(hTmpDC, tmpID)
    'Modify the menu
    menuID = GetMenuItemID(hMenuID, menuPos)
    retValue = ModifyMenu(hMenuID, menuPos, MF_BYPOSITION Or MF_BITMAP, _
               menuID, hBitmap)
    'Second menu item
    menuPos = 1
    fileName = App.Path & "\serif.bmp"
    Picture1.Picture = LoadPicture(fileName)
     'Create the bitmap for the picture
    hBitmap = CreateCompatibleBitmap(Picture1.hdc, Width, Height)
    'Select bitmap into temporary dc
    tmpID = SelectObject(hTmpDC, hBitmap)
    retValue = BitBlt(hTmpDC, 0, 0, Width, Height, _
               Picture1.hdc, 0, 0, SRCCOPY)
    tmpID = SelectObject(hTmpDC, tmpID)
    menuID = GetMenuItemID(hMenuID, menuPos)
    retValue = ModifyMenu(hMenuID, menuPos, MF_BYPOSITION Or MF_BITMAP, _
               menuID, hBitmap)
    'Third menu item
    menuPos = 2
    fileName = App.Path & "\comic.bmp"
    Picture1.Picture = LoadPicture(fileName)
     'Create the bitmap for the picture
    hBitmap = CreateCompatibleBitmap(Picture1.hdc, Width, Height)
    'Select bitmap into temporary dc
    tmpID = SelectObject(hTmpDC, hBitmap)
    retValue = BitBlt(hTmpDC, 0, 0, Width, Height, _
               Picture1.hdc, 0, 0, SRCCOPY)
    tmpID = SelectObject(hTmpDC, tmpID)
    menuID = GetMenuItemID(hMenuID, menuPos)
    retValue = ModifyMenu(hMenuID, menuPos, MF_BYPOSITION Or MF_BITMAP, _
               menuID, hBitmap)
    'Clean up
    retValue = DeleteDC(hTmpDC)
End Sub

Private Sub MyMenu_Click(Index As Integer)
Dim fName(3) As String
fName(0) = "Verdana"
fName(1) = "Serif"
fName(2) = "Comic Sans MS"
    Me.Cls
    Me.CurrentX = (Me.ScaleWidth - TextWidth(fName(Index))) / 2
    Me.CurrentY = (Me.ScaleHeight - TextHeight(fName(Index))) / 2
    Me.Font.Name = fName(Index)
    Me.Print fName(Index)
End Sub
